//
// Adventure Game for Cybiko by ssjx (2015)
//
// Wandering NPC's...
//
#include <cybiko.h>
#include "header.h"

// from mountain.c
int mountain_get(int ,int );

// utils.c
int abs(int);

// Ghost.c
int enemy_collide(struct myenemy,int, int);

struct myenemy bug[10];
struct Bitmap bmp_bug[2];

int bug_alt;

void bug_gfx()
{
	int i;

	struct Input * ptr_input;

	for(i=0;i<2;i++)
	{
		Bitmap_ctor(&bmp_bug[i]);	
	}
	
	ptr_input = open_resource_Ex( "bug.pic" );
	if (!Bitmap_load( &bmp_bug[0], ptr_input )){TRACE("Error loading bug");}
	Input_dtor( ptr_input, FREE_MEMORY );
	//	
	ptr_input = open_resource_Ex( "bug1.pic" );
	if (!Bitmap_load( &bmp_bug[1], ptr_input )){TRACE("Error loading bug");}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
}



void bug_clear()
{
	int i;
	for(i=0;i<10;i++)
	{
	bug[i].a=0;
	}
}

void bug_add(int sx,int sy)
{
	int i;
	for(i=0;i<10;i++)
	{
		if (bug[i].a==0)
		{
			bug[i].a=1;
			bug[i].x=sx;
			bug[i].y=sy;
			bug[i].ox=0;
			
			//
			if (random(10)>5)
			{
				bug[i].xdir=1;
			}
			else
			{
				bug[i].xdir=-1;
			}
			
			TRACE(" bug %d: %d , %d",i,sx,sy);
			
			return;
		}
	}
	
	TRACE("bug not added...");
}

int bug_hit(int px, int py)
{
	int i;
	
	for(i=0;i<10;i++)
	{
		if (bug[i].a==1)
		{
		if (enemy_collide(bug[i],px,py)==1){return 1;}
		}
	}
	
	return 0;
}

void bug_update()
{
	int i;
	int mg;
	int abx;

	for(i=0;i<10;i++)
	{
		if (bug[i].a==1)
		{		
			bug[i].ox+=bug[i].xdir;
			
			abx=abs(bug[i].ox);
			
			if (abx==16)
			{
				bug[i].ox=0;
				bug[i].x+=bug[i].xdir;
					
				// Check for wall
				mg=mountain_get(bug[i].x+bug[i].xdir,bug[i].y);
				
				// wall, breakable or space
				if (mg==1 || mg==6 || mountain_get(bug[i].x+bug[i].xdir,bug[i].y+1)==0)
				{
					bug[i].xdir*=-1;
				}
				
				bug_alt=1-bug_alt;
			}
			
			if (abx==4 || abx==8 || abx==12){bug_alt=1-bug_alt;}

		}
	}
}


void bug_draw(struct module_t *ptr_main_module,int mx,int my)
{
	int i;
	int ax,ay;
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	for(i=0;i<10;i++)
	{
		if (bug[i].a==1)
		{
			ax=(bug[i].x-(mx*10))<<4;	// <<4 = *16
			ay=(bug[i].y-(my*6))<<4;
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_bug[bug_alt], ax+bug[i].ox,ay, BM_NORMAL );
		}
	}
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}



