//
// Adventure Game for Cybiko by ssjx (2015)
//
// ** Fishing sub game **
//
#include <cybiko.h>

// in inventory.c
void inv_add(char *obj);
int inv_count(char *obj);

struct {
	int a;
	int x;
	int y;
	int xdir;
}fish[5];

struct Bitmap bmp_fish,bmp_fishr,bmp_seaweed,bmp_jelly,bmp_stonewater;

void fish_gfx()
{
	struct Input * ptr_input;

	Bitmap_ctor(&bmp_fish);
	
	ptr_input = open_resource_Ex( "green_fish_l.pic" );
	if (!Bitmap_load( &bmp_fish, ptr_input ))
	{
		TRACE("Error loading fish");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	Bitmap_ctor(&bmp_fishr);
	
	ptr_input = open_resource_Ex( "green_fish_r.pic" );
	if (!Bitmap_load( &bmp_fishr, ptr_input ))
	{
		TRACE("Error loading r fish");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_seaweed);
	
	ptr_input = open_resource_Ex( "plant.pic" );
	if (!Bitmap_load( &bmp_seaweed, ptr_input ))
	{
		TRACE("Error loading seaweed");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_jelly);
	
	ptr_input = open_resource_Ex( "jelly.pic" );
	if (!Bitmap_load( &bmp_jelly, ptr_input ))
	{
		TRACE("Error loading jellyfish");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
		//
	Bitmap_ctor(&bmp_stonewater);
	
	ptr_input = open_resource_Ex( "stone_water.pic" );
	if (!Bitmap_load( &bmp_stonewater, ptr_input ))
	{
		TRACE("Error loading water stone");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
}

void fish_set(int s)
{
	int i;

	// S 0 = Fish 1 = Jelly

	// Clear all (prevent stray fish with jellies!)
	for(i=0;i<5;i++)
	{
		fish[i].a=0;
	}


	switch(s)
	{
	case 0:
		// Fish
		for(i=0;i<5;i++)
		{
			fish[i].a=1;
		
			fish[i].x=random(10)*16;
			fish[i].y=(2+random(4))*16; // (2+i)*16
			
			if (random(10)>5)
			{
				fish[i].xdir=1;
			}
			else
			{
				fish[i].xdir=-1;
			}
				
		}
		
		
	break;
	
	case 1:
		for(i=0;i<4;i++)
		{
			fish[i].a=3;
		
			fish[i].x=random(10)*16;
			fish[i].y=(2+i)*16;
			
			if (random(10)>5)
			{
				fish[i].xdir=1;
			}
			else
			{
				fish[i].xdir=-1;
			}		
		}
		
		// If we do not have the water stone then it is still available
		if (inv_count("Water Stone")==0)
		{
		fish[3].a=4;
		}
	break;
	
	}

	
}


void fish_update()
{
	int i;
	for(i=0;i<5;i++)
	{
		switch(fish[i].a)
		{
		case 1:
		case 3:
		case 4:
		
			// FISH + JELLY + STONE Moving left and right
			if ((fish[i].x+fish[i].xdir)<=0 || (fish[i].x+fish[i].xdir)>=(160-16))
			{
				fish[i].xdir*=-1;
			}
			
			fish[i].x+=fish[i].xdir;
			
		break;
		
		case 2:	
			// Caught so moving upwards
			fish[i].y-=2;
			
			if (fish[i].y<=16)
			{
				inv_add("Fish");
				fish[i].a=0;
			}
		break;
		
		case 5:
			// Caught Water Stone
			fish[i].y-=2;
			
			if (fish[i].y<=16)
			{
				inv_add("Water Stone");
				fish[i].a=0;
			} 
		break;
		
		
		
		}	
	}
}

void fish_draw(struct module_t *ptr_main_module)
{
	int i;
	char *dis;
     	
	dis=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0); 

	// background
	memset(dis,0,1280);		// white
	memset(dis+1280,0x55,2820);	// lt gray
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
		
	// fish
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	for(i=0;i<5;i++)
	{
		
		switch(fish[i].a)
		{
		case 1:
		case 2:
			// Fish
			if (fish[i].xdir==1)
			{
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_fishr, fish[i].x,fish[i].y, BM_NORMAL );
			}
			else
			{
				Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_fish, fish[i].x,fish[i].y, BM_NORMAL );
			}
		break;
		
		case 3:
			// Jellies
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_jelly, fish[i].x,fish[i].y, BM_NORMAL );
		break;
		
		case 4:
		case 5:
			// Water stone
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_stonewater, fish[i].x,fish[i].y, BM_NORMAL );
		break;
		}
		
		
		
	}
	
	// Seaweed
	
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	for(i=0;i<10;i++)
	{
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_seaweed, (i*16),100-16, BM_NORMAL );
	}
	
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}

int fish_check(int x,int y)
{
	int i;

	for(i=0;i<5;i++)
	{
		// Fish swimming
		if (fish[i].a==1)
		{
			if (x>fish[i].x && x<fish[i].x+16)
			{
				if (y>fish[i].y && y<fish[i].y+16)
				{
				fish[i].a=2;
				return i;
				}
			}
		}
		
		if (fish[i].a==3)
		{
			if (x>fish[i].x && x<fish[i].x+16)
			{
				if (y>fish[i].y && y<fish[i].y+16)
				{
				return -2;
				}
			}
		}
		
		// Caught Stone
		if (fish[i].a==4)
		{
			if (x>fish[i].x && x<fish[i].x+16)
			{
				if (y>fish[i].y && y<fish[i].y+16)
				{
				fish[i].a=5;
				return i;
				}
			}
		}
		
	}

return -1;
}



