//
// Adventure Game for Cybiko by ssjx (2015)
//
// Adventure Game for Cybiko by ssjx (2015)
//
// Forest Ghosts...
//
#include <cybiko.h>
#include "header.h"

// from map.c
int map_get(int ,int );
int map_attr(int ,int );

// utils.c
int abs(int);

struct myenemy ghost[10];

struct Bitmap bmp_ghost;

void ghost_gfx()
{
	struct Input * ptr_input;

	Bitmap_ctor(&bmp_ghost);
	
	ptr_input = open_resource_Ex( "ghost.pic" );
	if (!Bitmap_load( &bmp_ghost, ptr_input ))
	{
		TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
}



void ghost_clear()
{
	int i;
	for(i=0;i<10;i++)
	{
	ghost[i].a=0;
	}
}

void ghost_add(int sx,int sy)
{
	int i;
	for(i=0;i<10;i++)
	{
		if (ghost[i].a==0)
		{
			ghost[i].a=1;
			ghost[i].x=sx;
			ghost[i].y=sy;
			ghost[i].ox=0;
			ghost[i].oy=0;
			ghost[i].xdir=0;
			ghost[i].ydir=0;
			
			TRACE(" ghost %d: %d , %d",i,sx,sy);
			
			return;
		}
	}
}

int enemy_collide(struct myenemy e,int px, int py)
{	
	const pw=8;
	int gx=(e.x*16)+e.ox;
	int gy=(e.y*16)+e.oy;
	
	// Narrow player
	px+=4;
	
//	TRACE("Pos %d , %d",gx,gy);
	
	if ((px>=gx && px<=gx+15) || (px+pw>=gx && px+15<=gx+15))
	{	
		if ((py>=gy && py<=gy+15) || (py+15>=gy && py+15<=gy+15))
		{
		TRACE("Hit!");
		return 1;
		}
	}		


return 0;
}

int ghost_hit(int px, int py)
{
	int i;
	
	for(i=0;i<10;i++)
	{
		if (ghost[i].a==1)
		{
		if (enemy_collide(ghost[i],px,py)==1){return 1;}
		}
	}
	
	return 0;
}




void ghost_update()
{

	int i,j,c;
	int a,b,t;
	int g;
	const int dir[8]={0,-1, 1,0, 0,1, -1,0};

	int order[]={0,2,4,6};

	for(i=0;i<10;i++)
	{
		if (ghost[i].a==1)
		{	
			if (ghost[i].xdir==0 && ghost[i].ydir==0)
			{
				// Jumble directions
				for(c=0;c<10;c++)
				{
					a=random(4);
					b=random(4);
					
					t=order[a];
					order[a]=order[b];
					order[b]=t;
				}
			
				// new direction
				for(c=0;c<4;c++)
				{
					j=order[c];
				
					ghost[i].xdir=dir[j];
					ghost[i].ydir=dir[j+1];
			
					// Check for a clear!
					if (map_attr(ghost[i].x+ghost[i].xdir,ghost[i].y+ghost[i].ydir)==0)
					{
					// Make sure it's not a path though
						if (map_get(ghost[i].x+ghost[i].xdir,ghost[i].y+ghost[i].ydir)!=1)
						{	
						break;
						}
					}
				}
			}
			else
			{
				
				ghost[i].ox+=(ghost[i].xdir*2);
				ghost[i].oy+=(ghost[i].ydir*2);
				
				if (abs(ghost[i].ox)==16 || abs(ghost[i].oy)==16)
				{
					ghost[i].ox=0;
					ghost[i].oy=0;
					
					ghost[i].x+=ghost[i].xdir;
					ghost[i].y+=ghost[i].ydir;
						
					// Check for wall
					if (map_attr(ghost[i].x+ghost[i].xdir,ghost[i].y+ghost[i].ydir)==1)
					{
						// Direction not clear
						ghost[i].xdir=0;
						ghost[i].ydir=0;
					}
					else
					{
						// Also, if path ahead, change direction
						if (map_get(ghost[i].x+ghost[i].xdir,ghost[i].y+ghost[i].ydir)==1)
						{
							// Direction not clear
							ghost[i].xdir=0;
							ghost[i].ydir=0;
						}
					}
				
				}
			}
			
		}
	}
}


void ghost_draw(struct module_t *ptr_main_module,int mx,int my)
{
	int ax,ay,i;
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	
	for(i=0;i<10;i++)
	{
		if (ghost[i].a==1)
		{
			ax=(ghost[i].x-(mx*10))<<4;	// <<4 = *16
			ay=(ghost[i].y-(my*6))<<4;
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_ghost, ax+ghost[i].ox,ay+ghost[i].oy, BM_NORMAL );
		}
	}
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}


