//
// Adventure for Breakfast (Cybiko) by ssjx (2015)
//


#include <cybiko.h>
#include "header.h"

void snapshot(char *);
int waitinput(struct module_t *);
void shadow(struct module_t *,char *,int );

// in shop.c
void center(struct module_t *,char *,int );

//
void map_load();
void map_draw(struct module_t *,int,int);
void map_redraw(struct module_t *);
int map_attr(int,int);
int map_get(int,int);
void map_set(int,int,int);
void map_save();
void map_restore();
void map_replace(int , int);


//
void mine_load();
void mine_draw(struct module_t *,int,int);
void mine_smartdraw(struct module_t *,int,int);
void mine_redraw(struct module_t *);
int mine_get(int,int);
void mine_set(int,int,int);
int mine_update();

void mine_save();
void mine_restore();

//
void mountain_load();
void mountain_draw(struct module_t *,int,int);
void mountain_redraw(struct module_t *);
int mountain_get(int,int);
void mountain_set(int,int,int);
void mountain_replace(int ,int);
void mountain_save();
void mountain_restore();

//
void player_draw(struct module_t *,int,int);
void player_load();
void player_boat(struct module_t *,int ,int);
void player_draw(struct module_t *,int ,int);

//

int title_draw(struct module_t *);
int title_welcome(struct module_t *);
void sign_draw(struct module_t *,int,int);
void loading_screen(struct module_t *, int );


void inv_clear();
void inv_save();
void inv_restore();
void inv_add(char *);
void inv_remove(char *,int);
int inv_display(struct module_t *);
int inv_count(char *);
//
//
//
void npc_gfx();
void npc_clear();
void npc_update();
void npc_draw(struct module_t *,int,int);
int npc_hit(int,int);
//

void ghost_gfx();
void ghost_clear();
void ghost_update();
void ghost_draw(struct module_t *,int,int);
int ghost_hit(int,int);

void spike_gfx();
void spike_clear();
int spike_update(int,int);
void spike_draw(struct module_t *,int,int);
int spike_hit(int,int);
void spike_reset();

//
void fish_gfx();
void fish_set(int);
void fish_update();
void fish_draw(struct module_t *);
int fish_check(int ,int );

//
void shop_gfx();
void shop_set();
void shop_draw(struct module_t *);
//

void bug_gfx();
void bug_clear();
void bug_update();
void bug_draw(struct module_t *,int,int);
int bug_hit(int,int);

//

void talk_gfx();
void talk_draw(struct module_t *,int);
int talk_start(char *);
void talk_quake(struct module_t *,int);
void talk_teleport(struct module_t *);
void talk_end(struct module_t *);

//
void task_set(int);
void task_draw(struct module_t *);
int task_current();
int task_status(int);
//
int abs(int);
//

struct module_t main_module;
struct DirectKeyboard *keys;

//
//
//



struct myplayer player;
struct myplayer player_bk;

int state=TOWN;
	
//

void player_save()
{
	player_bk.x=player.x;
	player_bk.y=player.y;
	player_bk.mx=player.mx;
	player_bk.my=player.my;
}

void player_restore()
{
	player.ox=0;
	player.oy=0;
	player.xdir=0;
	player.ydir=0;
	
	player.x=player_bk.x;
	if (player.x<0){player.x=0;}
	
	player.y=player_bk.y;
	if (player.y<0){player.y=0;}
	
	player.mx=player_bk.mx;
	player.my=player_bk.my;
}



//
//
//

void mountain_move(int xd,int yd)
{
int mg;

	if (player.xdir!=0){return;}
	if (player.ydir!=0){return;}
		
	if (yd==-1)
	{
	if (mountain_get(player.ax,player.ay)!=2){return;}
	}
	
	if (yd==1)
	{
	if (mountain_get(player.ax,player.ay+1)!=2){return;}
	}
	
	mg=mountain_get(player.ax+xd,player.ay+yd);
	if (mg!=1 && mg!=6)
	{
		player.xdir=xd;
		player.ydir=yd;	
	}
}

void mountain_update_player()
{
	if (player.xdir!=0 || player.ydir!=0)
	{ 
	//	TRACE("Moving");
		player.ox+=(player.xdir*4);
		player.oy+=(player.ydir*4);
	
		if (abs(player.ox)==16 || abs(player.oy)==16)
		{	
		//	TRACE("Moved");
			
			player.ox=0;
			player.oy=0;
			
			player.x+=player.xdir;
			player.y+=player.ydir;
			
			player.ax+=player.xdir;
			player.ay+=player.ydir;
			
			if (player.xdir!=0)
			{
				switch (player.x)
				{
				case -1:
				//	TRACE("Prev...");
				
					if (player.mx==0)
					{
						player.my=0;
						player.mx=1;
						player.x=5;
						player.y=0;
						player.xdir=0;
						player.ydir=0;
						player.ox=0;
						player.oy=0;
						
						player.ax=player.x+(player.mx*10);
						player.ay=player.y+(player.my*6);
						
						map_draw(&main_module,player.mx,player.my);
						state=TOWN;
						return;
					}
					else
					{
						player.mx--;
						player.x=9;
						mountain_draw(&main_module,player.mx,player.my);
					}
				break;
				case 10:	
				//	TRACE("Next...");					
					player.mx++;
					player.x=0;
					mountain_draw(&main_module,player.mx,player.my);	
				break;
				}
				
				player.xdir=0;
			}
			
			if (player.ydir!=0)
			{
				switch (player.y)
				{
				case -1:
				//	TRACE("Up...");
					player.my--;
					player.y=5;
					mountain_draw(&main_module,player.mx,player.my);
				break;
				case 6:
				//	TRACE("Down...");
					player.my++;
					player.y=0;
					mountain_draw(&main_module,player.mx,player.my);
				break;
				}
				
				player.ydir=0;
			}	
		}	
	}

	// Falling...
	if (player.xdir==0 && player.ydir==0)
	{
		if (mountain_get(player.ax,player.ay+1)==0)
		{
			player.ydir=1;	
		}
	}
}


//
//
//

int mine_update_player()
{
int g=-1;
int squashed=0;

	if (player.xdir!=0 || player.ydir!=0)
	{ 
	//	TRACE("Moving");
		player.ox+=(player.xdir*4);
		player.oy+=(player.ydir*4);
	
		if (abs(player.ox)==16 || abs(player.oy)==16)
		{	
			player.ox=0;
			player.oy=0;
			
			// Prev/Old position
			if (mine_get(player.ax,player.ay)==-1)
			{
				mine_set(player.ax,player.ay,0);			
			}
			
			player.x+=player.xdir;
			player.y+=player.ydir;
			
			// New position
			player.ax+=player.xdir;
			player.ay+=player.ydir;
			
			g=mine_get(player.ax,player.ay);
			
			switch(g)
			{
			case 3:
				g=1;
				inv_add("Diamonds");		
			break;
			case 7:
				g=1;
				inv_add("Earth Stone");		
			break;
			}

			// Moved into clear/mud space, mark that player there to prevent above falling rock			
			if (g==1 || g==0)
			{
				mine_set(player.ax,player.ay,-1);	// Prevent rock falling	
				
				// Only update if we have collected something
				if(g==1)
				{
					if (mine_update()==-1)
					{
						TRACE("slide squash!");
						squashed=1;
					}
				}	
			}
			
			
			player.xdir=0;
			player.ydir=0;
			
			switch (player.x)
			{
			case -1:
				player.mx--;
				player.x=9;
				mine_draw(&main_module,player.mx,player.my);
			break;
			case 10:
				player.mx++;
				player.x=0;
				mine_draw(&main_module,player.mx,player.my);
			break;
			}
			
			switch (player.y)
			{
			case -1:
				player.my--;
				player.y=5;
				mine_draw(&main_module,player.mx,player.my);
			break;
			case 6:
				player.my++;
				player.y=0;
				mine_draw(&main_module,player.mx,player.my);
			break;
			}
			
		
			mine_smartdraw(&main_module,player.mx,player.my);	
		}
	}

return squashed;
}

int mine_move(int xd, int yd)
{
	int g=-1;
	int squashed=0;

	if (player.xdir!=0){return 0;}
	if (player.ydir!=0){return 0;}
	
	g=mine_get(player.ax+xd,player.ay+yd);
	
	// Not wall or boulder
	if (g!=2 && g!=4)
	{
		player.xdir=xd;
		player.ydir=yd;
		
		if (yd==1)
		{
			// Move down + boulder above
			if (mine_get(player.ax,player.ay-1)==4)
			{
				// fake drop
				mine_set(player.ax,player.ay-1,0);
				mine_set(player.ax,player.ay,4);
				
				// redraw map
				mine_smartdraw(&main_module,player.mx,player.my);
				
				// splat!
				TRACE("Squashed!");
				squashed=1;
			}
		}		
	}	
	
	return squashed;	
}


void collect()
{
	int over;
		
	over=map_get(player.ax,player.ay);
	
	switch(over)
	{
	case 10:
		inv_add("Apple");
		map_set(player.ax,player.ay,0);
		map_draw(&main_module,player.mx,player.my);
	break;
	
	case 15:
		inv_add("Cherry");
		map_set(player.ax,player.ay,0);
		map_draw(&main_module,player.mx,player.my);
	break;
	
	case 17:
		inv_add("Earth Stone");
		map_set(player.ax,player.ay,0);
		map_draw(&main_module,player.mx,player.my);
	break;
	}
	
}

//
// TOWN Map moving
//

void move_player(int xd,int yd)
{
	if (player.xdir!=0){return;}
	if (player.ydir!=0){return;}
	
	if (map_attr(player.ax+xd,player.ay+yd)==0)
	{
		player.xdir=xd;
		player.ydir=yd;	
	}
}

void update_player()
{
	if (player.xdir!=0 || player.ydir!=0)
	{ 
		player.ox+=(player.xdir*4);
		player.oy+=(player.ydir*4);
	
		if (abs(player.ox)==16 || abs(player.oy)==16)
		{
			player.ox=0;
			player.oy=0;
			
			player.x+=player.xdir;
			player.y+=player.ydir;
			
			player.ax+=player.xdir;
			player.ay+=player.ydir;
			
			collect();
			
			if (player.xdir!=0)
			{
				player.xdir=0;
				
				switch (player.x)
				{
				case -1:
					
					// Entered Forest (save details before going in)
					if ((player.mx-1)==0 && player.my==2)
					{
						TRACE("Entered Forest!");
						map_save();
						inv_save();
						player_save();
					}
				
					player.mx--;
					player.x=9;
					map_draw(&main_module,player.mx,player.my);
						
				break;
				case 10:		
					if (player.mx==2)
					{
						if (player.my==0){fish_set(1);} // jelly
						if (player.my==1){fish_set(0);} // fish
						
						//TRACE("xd %d yd %d << Update Player",player.xdir,player.ydir);
						//TRACE("ox %d oy %d << Update Player",player.ox,player.oy);
						
						state=FISHING;
					}
					else
					{				
						player.mx++;
						player.x=0;
						map_draw(&main_module,player.mx,player.my);
					}
				break;
				}
				
			}
			
			if (player.ydir!=0)
			{
				player.ydir=0;
				switch (player.y)
				{
				case -1:
					if (player.mx==1 && player.my==0)
					{
						player_save();
						
						state=MOUNTAIN;
						
						player.mx=0;
						player.my=3;
						
						player.x=0;
						player.y=1;
						
						// Need to set this as actual does not match main map
						player.ax=player.x+(player.mx*10);
						player.ay=player.y+(player.my*6);
							
						mountain_draw(&main_module,player.mx,player.my);
					}
					else
					{
						player.my--;
						player.y=5;
						map_draw(&main_module,player.mx,player.my);
					}
				
				break;
				case 6:
					player.my++;
					player.y=0;
					map_draw(&main_module,player.mx,player.my);
				break;
				}
				
			}
		}	
	
		//player.ax=player.x+(player.mx*10);
		//player.ay=player.y+(player.my*6);
	
	}
	
}

//
//
// 
     
long main(int argc, char *argv[],bool start)
{
	char p_str[20],m_str[20];
	int ext=0;
	int i;
	int squashed=0;
	int infront;
		
	int key_enter=0;	
		
	int line;	
		
	init_module( &main_module );

	//
	// Load Graphics
	//
	
	npc_gfx();
	loading_screen(&main_module,0);
	
	ghost_gfx();
	loading_screen(&main_module,1);
	
	spike_gfx();
	loading_screen(&main_module,2);

	fish_gfx();
	loading_screen(&main_module,3);

	shop_gfx();
	loading_screen(&main_module,4);

	mine_gfx();
	loading_screen(&main_module,5);

	map_gfx();
	loading_screen(&main_module,6);

	bug_gfx();
	loading_screen(&main_module,7);

	mountain_gfx();
	loading_screen(&main_module,8);

	player_load();
	loading_screen(&main_module,9);

	talk_gfx();
	loading_screen(&main_module,10);

	// ---- Testing
	/*
	line=talk_start("#prof4");
	talk_draw(&main_module,line);

	// Screen transition
	talk_teleport(&main_module);
	
	// Been transported
	line=talk_start("#prof5");
	talk_draw(&main_module,line);
	
	talk_end(&main_module);
	ext=1;
	*/
	// -----

	//
	// Reset game
	//

	npc_clear();
	ghost_clear();
	spike_clear();
	bug_clear();
		
	mine_load();
	map_load();
	mountain_load();
	
	shop_set();

	//
	//
	map_draw(&main_module,0,0);
	map_redraw(&main_module);
	
	if(title_draw(&main_module)==1)
	{
		ext=1;
		state=0;
	}
	else
	{
		map_redraw(&main_module);
		title_welcome(&main_module);
	
		inv_clear();
		
		/*
		inv_add("Fish");
		inv_add("Fish");
		inv_add("Oats");
		inv_add("Cherry");
		inv_add("Cherry");
		inv_add("Apple");
		inv_add("Apple");
		inv_add("Milk");
		
		for(i=0;i<10;i++)
		{
		inv_add("Diamonds");
		}
		
		inv_add("Air Stone");
		inv_add("Earth Stone");
		inv_add("Fire Stone");
		inv_add("Water Stone");
		*/
		//
		//
		//
		
		player.x=3;
		player.y=4;
		player.mx=0;
		player.my=0;
		player.ox=0;
		player.oy=0;
		player.hook=0;
		
		task_set(0);
		
		map_draw(&main_module,player.mx,player.my);
	}
	
	do{
	
	
		switch(state)
		{
		case TOWN:
			map_redraw(&main_module);
			player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
			
			npc_draw(&main_module,player.mx,player.my);
			npc_update();
			
			update_player();
			
			// Only update ghosts when needed
			
			if (player.mx==0)
			{
				ghost_draw(&main_module,player.mx,player.my);
				ghost_update();
					
				if (ghost_hit((player.ax*16)+player.ox,(player.ay*16)+player.oy)==1)
				{
					TRACE("Hit ghost!");
					shadow(&main_module,"* HIT A GHOST! *",80);
				
					TGraph_set_color(main_module.m_gfx, CLR_LTGRAY );
					TGraph_fill_rect(main_module.m_gfx, 0, 90, 160, 10 );
					
					TGraph_set_color(main_module.m_gfx, CLR_BLACK );
					DisplayGraphics_draw_text(main_module.m_gfx, "Press Enter to continue..", 1,90 );
					
					DisplayGraphics_show(main_module.m_gfx );	
					
					do{}while(waitinput(&main_module)!=KEY_ENTER);
				
					map_restore();
					inv_restore();
					player_restore();
					
					map_draw(&main_module,player.mx,player.my);
				}
				
			}
			
			
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) )
			{
				
				if (player.ox==0 && player.oy==0)
				{		
					if (map_get(player.ax,player.ay)==14)
					{
						state=SHOP;
					}
				}
				
				if (state!=SHOP)
				{
					move_player(0,-1);
				}			
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) )
			{	
				move_player(0,1);
			}		
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
			{
				move_player(-1,0);	
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
			{ 
				move_player(1,0);	
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_ENTER )  )
			{
			key_enter=1;
			}
			
			
			if (player.ox==0 && player.oy==0)
			{
				player.ax=player.x+(player.mx*10);
				player.ay=player.y+(player.my*6);
						
				infront=map_get(player.ax,player.ay-1);
				switch(infront)
				{
				case 5:
					// In front of sign
					shadow(&main_module,"*Read this sign*",90);
					//TRACE("Sign Pos: %d x %d",player.ax,player.ay);
				break;
				
				case 12:
					shadow(&main_module,"*Talk to Mr Oldman*",90);
				break;
				
				case 13:
					shadow(&main_module,"*Talk to the guard*",90);
				break;
				}
			}
			
			
			if (key_enter==1 && DirectKeyboard_is_key_pressed( keys, KEY_ENTER )==FALSE)
			{
				key_enter=0;
				
				switch(infront)
				{
				case 5:
					// In front of sign
					sign_draw(&main_module,player.ax,player.ay-1);
				break;
				
				case 12:
					// Old man
					if (task_current()==0)
					{
						if (task_status(1)==1)
						{
							// Complete, been to mountains?
							line=talk_start("#oldman4");
							if (line>=0)
							{
								talk_draw(&main_module,line);
							}
						}
						else
						{
							// Task : Fetch Shopping
							line=talk_start("#oldman1");
							if (line>=0)
							{
								talk_draw(&main_module,line);
							}
							
							task_set(1);
						}
					}
					else
					{
						if (task_current()==1)
						{
							if (task_status(1)==0)
							{
								task_complete();
							}
							
							if (task_status(1)==1)
							{
								// Got all the stuff!
								line=talk_start("#oldman3");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
							
								// Got shopping
								inv_remove("Apple",2);
								inv_remove("Cherry",2);
								inv_remove("Fish",2);
								inv_remove("Milk",1);
								inv_remove("Oats",1);
								 
								inv_add("Air Stone");
								task_set(0);
							}
							else
							{
								// Need a reminder?
								line=talk_start("#oldman2");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
							//
							}
						}
					}
				break;
				
				case 13:
					// Guard
					if (task_status(1)==1)
					{
						// We've completed first task!
						if (task_current()==2)
						{
							if (task_status(2)==0)
							{
								task_complete();
							
								if (task_status(2)==1)
								{
									// Give sweets
									line=talk_start("#guard3");
									if (line>=0)
									{
										talk_draw(&main_module,line);
									}
								
									// remove top barrier
									map_set(14,0,0);
									map_set(15,0,0);
									map_draw(&main_module,player.mx,player.my);
									
									inv_remove("Sweets",1);
								 
									task_set(0);
								}
								else
								{
									// Bored, needs sweets	
									line=talk_start("#guard2");
									if (line>=0)
									{
										talk_draw(&main_module,line);
									}
								}
							}
							else
							{
								// Slurping the sweet...	
								line=talk_start("#guard4");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}	
							}
						
						}
						else
						{
						
							if (task_status(2)==0)
							{
								// Bored, needs sweets (not got task yet)	
								line=talk_start("#guard2");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
									
								task_set(2);
							}
							
							if (task_status(2)==1)
							{
								// Slurping the sweet...	
								line=talk_start("#guard4");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
							}
						}
						
						
					}
					else
					{
						// shall not pass..
						line=talk_start("#guard1");
						if (line>=0)
						{
							talk_draw(&main_module,line);
						}
					}	
				break;
				
				}
				
				//
				// On top of things!
				//
				// Hole
				
				infront=map_get(player.ax,player.ay);
				
				switch(infront)
				{
				case 11:
					// Save MINE to restore if hit while in mine
					mine_save();
					inv_save();
					player_save();
					spike_reset();
					mine_draw(&main_module,player.mx,player.my);
					state=ROCKFALL;
				break;
				
				case 14:
					// Shop entrance
					state=SHOP;
				break;
				}
				
				//takeshot=1;
			}
		break;
		
		
		case FISHING:
			fish_update();
			fish_draw(&main_module);
			player_boat(&main_module,player.boatx,player.hook);
		
			if (player.hook==0)
			{
				if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
				{
					if (player.boatx-2>=0)
					{
						player.boatx-=2;
					}
					else
					{
						player.x=9; // otherwise does not show..
						player.xdir=0;
						player.ydir=0;
						player.ox=0;
						player.oy=0;
							
						state=TOWN;
						
						//TRACE("xd %d yd %d << Leaving Fish",player.xdir,player.ydir);
						//TRACE("ox %d oy %d << Leaving Fish",player.ox,player.oy);
						
					}	
				}
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
				{	
					if (player.boatx+32+2<160){player.boatx+=2;}
				}
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_ENTER )  )
				{
					player.hook=1;
					player.hookdir=2;
					player.fish=-1;
				}
			}
			else
			{
				player.hook+=player.hookdir;
				
				if (player.fish==-1)
				{
					player.fish=fish_check(player.boatx+24+4,16+player.hook+6);
					if (player.fish!=-1 || player.fish==-2)
					{
					player.hookdir=-2;
					}
				}
				
				if ((player.hook+24)>=100){player.hookdir=-2;}
				if (player.hook<=0){player.hook=0;}
			}
			
		break;
		
		case ROCKFALL:
			mine_redraw(&main_module);
			player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
			spike_draw(&main_module,player.mx,player.my);
			
			squashed=mine_update_player();
			
			//mine_update();
			spike_update(player.ax,player.ay);
			
			//
			if (squashed==0)
			{
				if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) )
				{
					squashed=mine_move(0,-1);			
				}
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) )
				{	
					squashed=mine_move(0,1);
				}		
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
				{
					squashed=mine_move(-1,0);	
				}
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
				{
					squashed=mine_move(1,0);
				}
				
				if ( DirectKeyboard_is_key_pressed( keys, KEY_ENTER )  )
				{
					//player.ax=player.x+(player.mx*10);
					//player.ay=player.y+(player.my*6);
					
					if (mine_get(player.ax,player.ay)==6)
					{
						// Exit hole
						map_draw(&main_module,player.mx,player.my);
						state=TOWN;
					}
				}
			}
			
			if (squashed==1)
			{
		
				mine_draw(&main_module,player.mx,player.my);
				mine_redraw(&main_module);
				
				player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
				spike_draw(&main_module,player.mx,player.my);
				
				shadow(&main_module,"*SQUASHED BY A ROCK!*",80);
				
				TGraph_set_color(main_module.m_gfx, CLR_LTGRAY );
				TGraph_fill_rect(main_module.m_gfx, 0, 90, 160, 10 );
				
				TGraph_set_color(main_module.m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text(main_module.m_gfx, "Press Enter to continue..", 1,90 );
				
				DisplayGraphics_show(main_module.m_gfx );
					
				do{}while(waitinput(&main_module)!=KEY_ENTER);
				
				// restore all
				mine_restore();
				inv_restore();
				player_restore();
				
				map_draw(&main_module,player.mx,player.my);
				state=TOWN;
				squashed=0;
			}
			
			if (spike_hit((player.ax*16)+player.ox,(player.ay*16)+player.oy)==1)
			{
				mine_draw(&main_module,player.mx,player.my);
				mine_redraw(&main_module);
				
				player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
				spike_draw(&main_module,player.mx,player.my);
				
				shadow(&main_module,"*HIT A SPIKE!*",90);
				
				TGraph_set_color(main_module.m_gfx, CLR_LTGRAY );
				TGraph_fill_rect(main_module.m_gfx, 0, 90, 160, 10 );
				
				TGraph_set_color(main_module.m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text(main_module.m_gfx, "Press Enter to continue..", 1,90 );
				
				DisplayGraphics_show(main_module.m_gfx );	
				do{}while(waitinput(&main_module)!=KEY_ENTER);
			
				TRACE("Hit Spike!");
				mine_restore();
				inv_restore();
				player_restore();
				
				map_draw(&main_module,player.mx,player.my);
				state=TOWN;
			}
		
		break;
		
		case MOUNTAIN:
			mountain_redraw(&main_module);
			player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
			bug_draw(&main_module,player.mx,player.my);
			
			bug_update();
			
			mountain_update_player();
			
			if (player.ox==0 && player.oy==0)
			{
				//player.ax=player.x+(player.mx*10);
				//player.ay=player.y+(player.my*6);
				infront=mountain_get(player.ax+1,player.ay);
				switch(infront)
				{
				case 4:
					// In front of sign
					shadow(&main_module,"*Talk to Prof. White*",90);
				break;
				}
			}
			
			//Process_pause(main_module.m_process, 1);
			//jumble();
			//
			if ( DirectKeyboard_is_key_pressed( keys, KEY_UP ) || DirectKeyboard_is_key_pressed( keys, KEY_Q ) )
			{
				mountain_move(0,-1);	
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_DOWN ) || DirectKeyboard_is_key_pressed( keys, KEY_A) )
			{	
				mountain_move(0,1);
			}		
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_LEFT ) || DirectKeyboard_is_key_pressed( keys, KEY_O ) )
			{
				mountain_move(-1,0);
			}
			
			if ( DirectKeyboard_is_key_pressed( keys, KEY_RIGHT ) || DirectKeyboard_is_key_pressed( keys, KEY_P) )
			{
				mountain_move(1,0);
			}
		
			if ( DirectKeyboard_is_key_pressed( keys, KEY_ENTER )  )
			{
				key_enter=1;
			}
		
			if (key_enter==1 && DirectKeyboard_is_key_pressed( keys, KEY_ENTER )==FALSE)
			{
				key_enter=0;
				
				if (infront==4)
				{
				
					if (task_current()==0)
					{
						// Hello! Then places stone
						line=talk_start("#prof1");
						if (line>=0)
						{
							talk_draw(&main_module,line);
						}
						
						// Screen shake
						talk_quake(&main_module,1);
						
						// Get other stones
						line=talk_start("#prof2");
						if (line>=0)
						{
							talk_draw(&main_module,line);
						}
						
						// Remove all boulders
						map_replace(8,0);
						mountain_replace(6,0);
						
						// redraw as still in mountain...
						mountain_draw(&main_module,player.mx,player.my);
						task_set(3);
					}
					else
					{
						if (task_current()==3)
						{
							if (task_complete()==1)
							{
								// Got all stones
								line=talk_start("#prof4");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
								
								// Screen transition
								
								talk_teleport(&main_module);
								
								// Been transported
								line=talk_start("#prof5");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}	
								
								// Completed Game! Yay!
								ext=2;
							}
							else
							{
								line=talk_start("#prof3");
								if (line>=0)
								{
									talk_draw(&main_module,line);
								}
							}
						}
					}
					
					
					
					
				}
			}
			
			//
			//
			//
			
			if (bug_hit((player.ax*16)+player.ox,(player.ay*16)+player.oy)==1)
			{
				//mountain_draw(&main_module,player.mx,player.my);
				mountain_redraw(&main_module);
				
				player_draw(&main_module,(player.x<<4)+player.ox,(player.y<<4)+player.oy);
				bug_draw(&main_module,player.mx,player.my);
				
				shadow(&main_module,"*HIT A MONSTER!*",80);
				
				TGraph_set_color(main_module.m_gfx, CLR_LTGRAY );
				TGraph_fill_rect(main_module.m_gfx, 0, 90, 160, 10 );
				
				TGraph_set_color(main_module.m_gfx, CLR_BLACK );
				DisplayGraphics_draw_text(main_module.m_gfx, "Press Enter to continue..", 1,90 );
				
				DisplayGraphics_show(main_module.m_gfx );
					
				do{}while(waitinput(&main_module)!=KEY_ENTER);
			
				TRACE("Hit Bug!");
				
				//mountain_restore();
				//inv_restore();
				player_restore();
				
				map_draw(&main_module,player.mx,player.my);
				state=TOWN;
			}
			
		break;
		
		case SHOP:	
			shop_draw(&main_module);
			state=TOWN;
		break;
		}
	
		//
		// Always able to do these things
		//
		
		if ( DirectKeyboard_is_key_pressed( keys, KEY_X ) )
		{
			ext=1;
		}
		
		if ( DirectKeyboard_is_key_pressed( keys, KEY_H )  )
		{
			//takeshot=1;
		}
		
		if ( DirectKeyboard_is_key_pressed( keys, KEY_I )  )
		{
			inv_display(&main_module);
		}
		
		if ( DirectKeyboard_is_key_pressed( keys, KEY_T )  )
		{
			task_draw(&main_module);
		}
	
	DisplayGraphics_show(main_module.m_gfx );	
		
	}while(ext==0);
	
	if (ext==2)
	{
	talk_end(&main_module);
	}
	
	//
	//
	//
	
	TRACE("Finished");
	
	//set_click_kind( click_type );
	
	//DirectKeyboard_dtor( keys, FREE_MEMORY );
	
	return 0L;
}
