//
// Adventure Game for Cybiko by ssjx (2015)
//

//
// 256 BMP loader
//
#include <cybiko.h>
#include "bmp.h"

#define MAPSIZE 32

//
void npc_add(int,int);
void ghost_add(int,int);

//

void mine_set(int,int,int);

// utils.c
long swp(long num);

//


char map[1024];
char map_bk[1024];
char attr[1024];

//
struct Bitmap bmp_grass,bmp_path,bmp_tree,bmp_water,bmp_sign,bmp_shop,bmp_house,bmp_boulder;
struct Bitmap bmp_apple,bmp_hole,bmp_oldman,bmp_guard,bmp_cherry,bmp_pathshop,bmp_barrier,bmp_stoneearth;
struct Bitmap bmp_flower;

//
// Load our graphics
//

void map_gfx()
{
	//
	
	struct Input * ptr_input;
	
	Bitmap_ctor(&bmp_grass);
	
	ptr_input = open_resource_Ex( "grass.pic" );
	if (!Bitmap_load( &bmp_grass, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_path);
	
	ptr_input = open_resource_Ex( "path.pic" );
	if (!Bitmap_load( &bmp_path, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_water);
	
	ptr_input = open_resource_Ex( "water.pic" );
	if (!Bitmap_load( &bmp_water, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	//
	Bitmap_ctor(&bmp_tree);
	
	ptr_input = open_resource_Ex( "tree.pic" );
	if (!Bitmap_load( &bmp_tree, ptr_input ))
	{
	TRACE("Error loading tree");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_sign);
	
	ptr_input = open_resource_Ex( "sign_info.pic" );
	if (!Bitmap_load( &bmp_sign, ptr_input ))
	{
	TRACE("Error loading sign");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	
	//
	Bitmap_ctor(&bmp_shop);
	
	ptr_input = open_resource_Ex( "building2.pic" );
	if (!Bitmap_load( &bmp_shop, ptr_input ))
	{
	TRACE("Error loading shop");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_house);
	
	ptr_input = open_resource_Ex( "building1.pic" );
	if (!Bitmap_load( &bmp_house, ptr_input ))
	{
	TRACE("Error loading shop");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_boulder);
	
	ptr_input = open_resource_Ex( "boulder.pic" );
	if (!Bitmap_load( &bmp_boulder, ptr_input ))
	{
	TRACE("Error loading boulder");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
		//
	Bitmap_ctor(&bmp_apple);
	
	ptr_input = open_resource_Ex( "red_apple.pic" );
	if (!Bitmap_load( &bmp_apple, ptr_input ))
	{
	TRACE("Error loading apple");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_hole);
	
	ptr_input = open_resource_Ex( "hole.pic" );
	if (!Bitmap_load( &bmp_hole, ptr_input ))
	{
	TRACE("Error loading hole");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_oldman);
	
	ptr_input = open_resource_Ex( "oldman.pic" );
	if (!Bitmap_load( &bmp_oldman, ptr_input ))
	{
	TRACE("Error loading oldman");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
		//
	Bitmap_ctor(&bmp_guard);
	
	ptr_input = open_resource_Ex( "guard.pic" );
	if (!Bitmap_load( &bmp_guard, ptr_input ))
	{
	TRACE("Error guard");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_pathshop);
	
	ptr_input = open_resource_Ex( "path_shop.pic" );
	if (!Bitmap_load( &bmp_pathshop, ptr_input ))
	{
	TRACE("Error loading path");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	Bitmap_ctor(&bmp_cherry);
	
	ptr_input = open_resource_Ex( "cherry.pic" );
	if (!Bitmap_load( &bmp_cherry, ptr_input ))
	{
	TRACE("Error loading path");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	Bitmap_ctor(&bmp_barrier);
	
	ptr_input = open_resource_Ex( "barrier.pic" );
	if (!Bitmap_load( &bmp_barrier, ptr_input ))
	{
	TRACE("Error loading barrier");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//	
	Bitmap_ctor(&bmp_stoneearth);
	
	ptr_input = open_resource_Ex( "stone_earth.pic" );
	if (!Bitmap_load( &bmp_stoneearth, ptr_input ))
	{
	TRACE("Error loading earth stone");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//	
	Bitmap_ctor(&bmp_flower);
	
	ptr_input = open_resource_Ex( "flower.pic" );
	if (!Bitmap_load( &bmp_flower, ptr_input ))
	{
	TRACE("Error loading earth stone");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	
}

void map_save()
{
memcpy(map_bk,map,sizeof(map_bk));
}

void map_restore()
{
memcpy(map,map_bk,sizeof(map));
}

	
struct bitmap_info bminfo;	


void map_load()
{
	int i,j,c,y,pos;
	long offset;	
	char *tmp;

	struct bitmap_header bmheader;

	struct Input *bmp_file_input;
	
	tmp=(char *)malloc(MAPSIZE*MAPSIZE); 
	
	if (tmp==0)
	{
		TRACE("Not Enough Memory (TMP Buffer)..");
		return;
	}

	TRACE("Loading TOWN map..");
		
	//
	// Load map from a resource
	//
	// Can't seek within a bmp so am just skipping until i get to data
	//
	bmp_file_input=open_resource_Ex( "map.bmp" );
	Input_read( bmp_file_input, tmp,78);
	Input_read( bmp_file_input, tmp,1000);
	Input_read( bmp_file_input, tmp,MAPSIZE*MAPSIZE); // <<-- Actual map!
	Input_dtor( bmp_file_input, FREE_MEMORY );

	c=0;
	pos=0;
	for(j=0;j<MAPSIZE;j++)
	{
		for(i=0;i<MAPSIZE;i++)
		{
		pos=(MAPSIZE-1-j)*MAPSIZE;
		map[pos+i]=tmp[c];
		c++;
		}
	}

	free(tmp);
	
	//
	// Sort out attributes
	//
	c=0;
	for(j=0;j<MAPSIZE;j++)
	{
		for(i=0;i<MAPSIZE;i++)
		{
			attr[c]=0;
			if (map[c]==2 || map[c]==3 || map[c]==5 || map[c]==8 || map[c]==16){attr[c]=1;}
			
			// Can't walk through people...
			if (map[c]==12 || map[c]==13){attr[c]=1;}
			
			switch (map[c])
			{
			case 4:
				// Wandering NPC
				npc_add(i,j);
				map[c]=1;
			break;
			
			case 7:
				// Ghost
				ghost_add(i,j);
				map[c]=0;
			break;
			
			case 11:
				// Mine exit
				mine_set(i,j,6);
			break;
			}
			
			c++;
		}
	}
	
	// Large sprite attributes
	c=0;
	for(j=0;j<MAPSIZE;j++)
	{
		for(i=0;i<MAPSIZE;i++)
		{
			if (map[c]==6 || map[c]==9)
			{
				for(y=0;y<3;y++)
				{
					//(y*MAPSIZE)+
					attr[(y*MAPSIZE)+c]=1;
					attr[(y*MAPSIZE)+c+1]=1;
					attr[(y*MAPSIZE)+c+2]=1;	
				}
			}
			c++;
		}
	}
	
	

}



void map_redraw(struct module_t *ptr_main_module)
{
  DisplayGraphics_page_copy( ptr_main_module->m_gfx, 1, 0, 0, 0, 160, 100 );
              

}

void map_draw(struct module_t *ptr_main_module,int x,int y)
{
	int i,j,pos;
	int spr,c;

	
	DisplayGraphics_set_page( ptr_main_module->m_gfx, 1 );

	for(j=0;j<6;j++)
	{
		pos=(MAPSIZE*(y*6))+(j*MAPSIZE)+(x*10);
		
		for(i=0;i<10;i++)
		{
			spr=map[pos];
			// <<4 = *16
			switch(spr)
			{
				case 0:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_grass, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 1:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_path, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 2:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_water, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 3:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tree, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 4:
					// Skipped as is player colour
				break;
				
				case 5:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_sign, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 6:
					// house
				break;
				
				case 7:
					// Skipped as is ghost colour
				break;
				
				case 8:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_boulder, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 10:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_apple, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 11:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_hole, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 12:
					// Oldman
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_oldman, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 13:
					// Guard
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_guard, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 14:
					// Shop entrance
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_pathshop, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 15:
					// Cherry
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_cherry, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 16:
					// Barrier
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_barrier, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 17:
					// Barrier
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_stoneearth, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 18:
					// Flower
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_flower, i<<4,j<<4, BM_NORMAL );
				break;
				
			}
			pos++;
		}
	}
	
	//
	// Second pass for big sprites
	//
	for(j=0;j<6;j++)
	{
		pos=(MAPSIZE*(y*6))+(j*MAPSIZE)+(x*10);
		
		for(i=0;i<10;i++)
		{
			spr=map[pos];
			
			switch(spr)
			{	
				case 6:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_house, i<<4,j<<4, BM_NORMAL );
				break;
				
				case 9:
					Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_shop, i<<4,j<<4, BM_NORMAL );
				break;
			}
			pos++;
		}
	}
	
	
	DisplayGraphics_set_page( ptr_main_module->m_gfx, 0 );
}


void map_replace(int a, int b)
{
	int i,j,c=0;

	for(j=0;j<MAPSIZE;j++)
	{
		for(i=0;i<MAPSIZE;i++)
		{
			if (map[c]==a)
			{
				map[c]=b;
				map_bk[c]=b;
			
				// reset the attribute for block	
				attr[c]=0;
				if (map[c]==2 || map[c]==3 || map[c]==5 || map[c]==8 || map[c]==16){attr[c]=1;}
			}
		
			c++;
		}
	}
}


int map_get(int x,int y)
{
	int pos=(y*MAPSIZE)+x;	//32 == <<5
	return map[pos];
}

void map_set(int x,int y,int c)
{
	int pos=(y*MAPSIZE)+x;	//32 == <<5
	
	if (pos<(MAPSIZE*MAPSIZE))
	{
		map[pos]=c;
		if (c==0){attr[pos]=0;}
	}
	else
	{
		TRACE("Error! Map Set Overflow");
	}
}


int map_attr(int x,int y)
{
	int pos=(y*MAPSIZE)+x;
	return attr[pos];
}

