//
// Adventure Game for Cybiko by ssjx (2015)
//
// Wandering NPC's...
//
#include <cybiko.h>
#include "header.h"

// from map.c
int map_get(int ,int );
int map_attr(int ,int );

// from ghost.c
int enemy_collide(struct myenemy ,int , int );

// utils.c
int abs(int);

struct myenemy npc[10];

int npc_alt;

struct Bitmap npc_player[4];

void npc_gfx()
{
	struct Input * ptr_input;
	int i;

	for(i=0;i<4;i++)
	{
	Bitmap_ctor(&npc_player[i]);
	}
		
	ptr_input = open_resource_Ex( "npc_left.pic" );
	if (!Bitmap_load( &npc_player[0], ptr_input )){TRACE("Error loading npc");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "npc_right.pic" );
	if (!Bitmap_load( &npc_player[1], ptr_input )){TRACE("Error loading npc");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "npc_up.pic" );
	if (!Bitmap_load( &npc_player[2], ptr_input )){TRACE("Error loading npc");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "npc_down.pic" );
	if (!Bitmap_load( &npc_player[3], ptr_input )){TRACE("Error loading npc");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
}

int npc_hit(int px, int py)
{
	int i;
	
	for(i=0;i<10;i++)
	{
		if (npc[i].a==1)
		{
		if (enemy_collide(npc[i],px,py)==1){return 1;}
		}
	}
	
	return 0;
}

void npc_clear()
{
	int i;
	for(i=0;i<10;i++)
	{
	npc[i].a=0;
	}
}

void npc_add(int sx,int sy)
{
	int i;
	for(i=0;i<10;i++)
	{
		if (npc[i].a==0)
		{
			npc[i].a=1;
			npc[i].x=sx;
			npc[i].y=sy;
			npc[i].xdir=0;
			npc[i].ydir=0;
			npc[i].ox=0;
			npc[i].oy=0;
			npc[i].facing=3;
			
			
			TRACE(" npc %d: %d , %d",i,sx,sy);
			
			return;
		}
	}
}



void npc_update()
{

	int i,j,c;
	int a,b,t;
	const int dir[8]={0,-1, 1,0, 0,1, -1,0};

	int order[]={0,2,4,6};
	
	for(i=0;i<10;i++)
	{
		if (npc[i].a==1)
		{
			if (npc[i].xdir==0 && npc[i].ydir==0)
			{
				// Jumble directions
				for(c=0;c<10;c++)
				{
					a=random(4);
					b=random(4);
					
					t=order[a];
					order[a]=order[b];
					order[b]=t;
				}
			
				// new direction
				for(c=0;c<4;c++)
				{
					j=order[c];
				
					npc[i].xdir=dir[j];
					npc[i].ydir=dir[j+1];
					
					if (map_get(npc[i].x+npc[i].xdir,npc[i].y+npc[i].ydir)==1)
					{	
					break;
					}
				}
			}
			else
			{
				
				npc[i].ox+=(npc[i].xdir*2);
				npc[i].oy+=(npc[i].ydir*2);
				
				if (abs(npc[i].ox)==16 || abs(npc[i].oy)==16)
				{
					npc[i].ox=0;
					npc[i].oy=0;
					
					npc[i].x+=npc[i].xdir;
					npc[i].y+=npc[i].ydir;
						
					if (map_get(npc[i].x+npc[i].xdir,npc[i].y+npc[i].ydir)!=1)
					{
						// Direction not clear
						npc[i].xdir=0;
						npc[i].ydir=0;
					}
				
				}
			}
			
		}
	}
}


void npc_draw(struct module_t *ptr_main_module,int mx,int my)
{
	int i;
	int ax,ay;
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_DKGRAY );
	
	for(i=0;i<10;i++)
	{
		if (npc[i].a==1)
		{
		ax=(npc[i].x-(mx*10))<<4;	// <<4 = *16
		ay=(npc[i].y-(my*6))<<4;
		
		if (npc[i].xdir==-1){npc[i].facing=0;}
		if (npc[i].xdir==1){npc[i].facing=1;}
		if (npc[i].ydir==-1){npc[i].facing=2;}
		if (npc[i].ydir==1){npc[i].facing=3;}
		
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &npc_player[npc[i].facing], ax+npc[i].ox, ay+npc[i].oy, BM_NORMAL );
		}
	}
	
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}

