//
// Adventure Game for Cybiko by ssjx (2015)
//

#include <cybiko.h>
#include "header.h"

struct Bitmap bmp_player[4],bmp_boat,bmp_hook;

extern struct myplayer player;

int facing;

void player_load()
{
	struct Input * ptr_input;
	int i;

	for(i=0;i<4;i++)
	{
	Bitmap_ctor(&bmp_player[i]);
	}
	
	ptr_input = open_resource_Ex( "player_left.pic" );
	if (!Bitmap_load( &bmp_player[0], ptr_input )){TRACE("Error loading");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "player_right.pic" );
	if (!Bitmap_load( &bmp_player[1], ptr_input )){TRACE("Error loading");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "player_up.pic" );
	if (!Bitmap_load( &bmp_player[2], ptr_input )){TRACE("Error loading");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "player_down.pic" );
	if (!Bitmap_load( &bmp_player[3], ptr_input )){TRACE("Error loading");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	//
	//
	
	Bitmap_ctor(&bmp_boat);	
	ptr_input = open_resource_Ex( "boat.pic" );
	if (!Bitmap_load( &bmp_boat, ptr_input ))
	{
		TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );	
	
	//
	Bitmap_ctor(&bmp_hook);	
	ptr_input = open_resource_Ex( "hook.pic" );
	if (!Bitmap_load( &bmp_hook, ptr_input ))
	{
		TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	facing=3;
	
}

void player_draw(struct module_t *ptr_main_module,int i,int j)
{
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_DKGRAY );

	if (player.xdir==-1){facing=0;}
	if (player.xdir==1){facing=1;}
	if (player.ydir==-1){facing=2;}
	if (player.ydir==1){facing=3;}
	
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_player[facing], i,j, BM_NORMAL );

	// Put drawing back to normal!
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}

void player_boat(struct module_t *ptr_main_module,int i,int hook)
{
  	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
  	
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_boat, i,16, BM_NORMAL );
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_hook, i+24,16+hook, BM_NORMAL );
	
	// Put drawing back to normal!
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
	//
	if (hook>0)
	{
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
     	TGraph_draw_line( ptr_main_module->m_gfx, i+28, 16, i+28, 16+hook );
	}
	
	
}
