//
// Adventure Game for Cybiko by ssjx (2015)
//
// ** shop **
//
#include <cybiko.h>

int waitinput(struct module_t *);

void inv_add(char *);
int inv_count(char *);
void inv_remove(char *,int);

struct
{
	char name[15];
	int cost;
	int qty;
}shopitem[4];

int itemno;

struct Bitmap bmp_milk,bmp_oats,bmp_sweets,bmp_fstone,bmp_dia;


void shop_gfx()
{
	struct Input * ptr_input;
	
	Bitmap_ctor(&bmp_milk);
	
	ptr_input = open_resource_Ex( "milk.pic" );
	if (!Bitmap_load( &bmp_milk, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_oats);
	
	ptr_input = open_resource_Ex( "oats.pic" );
	if (!Bitmap_load( &bmp_oats, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_sweets);
	
	ptr_input = open_resource_Ex( "sweets.pic" );
	if (!Bitmap_load( &bmp_sweets, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	//
	
	Bitmap_ctor(&bmp_fstone);
	
	ptr_input = open_resource_Ex( "fire32.pic" );
	if (!Bitmap_load( &bmp_fstone, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
	Bitmap_ctor(&bmp_dia);
	
	ptr_input = open_resource_Ex( "dia8.pic" );
	if (!Bitmap_load( &bmp_dia, ptr_input ))
	{
	TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//

}


void center(struct module_t *ptr_main_module,char *text,int y)
{
	int width,pos;
	
	width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	
	pos=(160-width)>>1;	    
	if (pos<0){pos=0;}
	
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}

void right(struct module_t *ptr_main_module,char *text,int y)
{
	int width,pos;
	
	width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	
	pos=160-width-1;	    
	if (pos<0){pos=0;}
	
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}


void shop_set()
{
	strncpy(shopitem[0].name,"Oats",sizeof(shopitem[0].name)-1);
	shopitem[0].cost=5;
	shopitem[0].qty=10;
	
	strncpy(shopitem[1].name,"Milk",sizeof(shopitem[1].name)-1);
	shopitem[1].cost=5;
	shopitem[1].qty=10;
	
	strncpy(shopitem[2].name,"Sweets",sizeof(shopitem[2].name)-1);
	shopitem[2].cost=5;
	shopitem[2].qty=10;
	
	strncpy(shopitem[3].name,"Fire Stone",sizeof(shopitem[3].name)-1);
	shopitem[3].cost=25;
	shopitem[3].qty=1;
	
	itemno=0;
}



void shop_draw(struct module_t *ptr_main_module)
{
	char tmp[30];
	int diamonds;
	int ext=0;
	
	do
	{
		diamonds=inv_count("Diamonds");
			
		TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	     	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
	
		TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );	
		TGraph_draw_line( ptr_main_module->m_gfx, 0, 11, 160, 11 );
		
		// Arrow
		TGraph_draw_line( ptr_main_module->m_gfx, 20, 20, 5, 50 );
		TGraph_draw_line( ptr_main_module->m_gfx, 5, 50, 20, 80 );
		
		TGraph_draw_line( ptr_main_module->m_gfx, 140, 20, 155, 50 );
		TGraph_draw_line( ptr_main_module->m_gfx, 155, 50, 140, 80 );
		
	
		DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Shop", 1, 1 );
		
		sprintf(tmp,"x%d",diamonds);
		DisplayGraphics_draw_text( ptr_main_module->m_gfx, tmp, 140, 1 );
		
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_dia, 130, 2, BM_NORMAL );
			
		/// Footer
		TGraph_set_color( ptr_main_module->m_gfx, CLR_LTGRAY );
		TGraph_fill_rect(ptr_main_module->m_gfx, 0, 90, 160, 10 );
		
		TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
		DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Enter=Buy", 1,90 );
			
		right(ptr_main_module,"Esc=Leave",90);	
			
		// Item info		
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
		TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	
		switch(itemno)
		{
		case 0:
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_oats, (160-32)/2, 16, BM_NORMAL );
		break;
		
		case 1:
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_milk, (160-32)/2, 16, BM_NORMAL );
		break;
		
		case 2:
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_sweets, (160-32)/2, 16, BM_NORMAL );
		break;
		
		case 3:
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_fstone, (160-32)/2, 16, BM_NORMAL );
		break;
		
		}
		
		// Put drawing back to normal!
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
		
		TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
		center(ptr_main_module,shopitem[itemno].name,56);
		
		sprintf(tmp,"Cost %d Diamonds",shopitem[itemno].cost);
		center(ptr_main_module,tmp,68);
		
		if (shopitem[itemno].qty>0)
		{
			if (diamonds>=shopitem[itemno].cost)	
			{
				
				center(ptr_main_module,"Buy it now!",80);
			}
			else
			{
				TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
				center(ptr_main_module,"Need more diamonds!",80);//
			}
		}
		else
		{
			TGraph_set_color(ptr_main_module->m_gfx, CLR_LTGRAY );
			center(ptr_main_module,"Not in stock..",80);	
		}
	
		DisplayGraphics_show(ptr_main_module->m_gfx );
		
		switch(waitinput(ptr_main_module))
		{
			case KEY_LEFT:
			case KEY_O:
				shop_prev();
			break;
			
			case KEY_RIGHT:
			case KEY_P:
				shop_next();
			break;
			
			case KEY_ENTER:
				shop_buy();
			break;
			
			case KEY_ESC:
				ext=1;
			break;
		}
		
	}while(ext==0);

	
}


void shop_next()
{
	itemno++;
	if (itemno>3){itemno=0;}
}

void shop_prev()
{
	itemno--;
	if (itemno<0){itemno=3;}
}

void shop_buy()
{
	int diamonds;
	int cost;
	
	diamonds=inv_count("Diamonds");
	cost=shopitem[itemno].cost;
	
	if (diamonds>=cost)
	{
		inv_add(shopitem[itemno].name);
		inv_remove("Diamonds",cost);
		shopitem[itemno].qty--;
	}
}


