//
// Adventure Game for Cybiko by ssjx (2015)
//
// Mine Spikes
//
#include <cybiko.h>
#include "header.h"

// from mine.c
int mine_get(int ,int );

// utils.c
int abs(int);

// Ghost.c
int enemy_collide(struct myenemy,int, int);

struct myenemy spike[10];

struct Bitmap bmp_spike;

void spike_gfx()
{
	struct Input * ptr_input;

	Bitmap_ctor(&bmp_spike);
	
	ptr_input = open_resource_Ex( "spike.pic" );
	if (!Bitmap_load( &bmp_spike, ptr_input ))
	{
		TRACE("Error loading");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
}



void spike_clear()
{
	int i;
	for(i=0;i<10;i++)
	{
	spike[i].a=0;
	}
}

void spike_add(int sx,int sy)
{
	int i;
	for(i=0;i<10;i++)
	{
		if (spike[i].a==0)
		{
			spike[i].a=1;
			spike[i].x=sx;
			spike[i].y=sy;
			spike[i].ox=0;
			spike[i].oy=0;
			spike[i].xdir=0;
			spike[i].ydir=0;
			
			spike[i].dx=sx;
			spike[i].dy=sy;
			
			TRACE(" spike %d: %d , %d",i,sx,sy);
			
			return;
		}
	}
}

// Reset spikes otherwise they could reappear in solid ground
void spike_reset()
{
	int i;

	for(i=0;i<10;i++)
	{
		if (spike[i].a==1)
		{
			spike[i].a=1;
			spike[i].x=spike[i].dx;
			spike[i].y=spike[i].dy;
			spike[i].ox=0;
			spike[i].oy=0;
			spike[i].xdir=0;
			spike[i].ydir=0;
		}
	}
}

int spike_hit(int px, int py)
{
	int i;
	
	for(i=0;i<10;i++)
	{
		if (spike[i].a==1)
		{
		if (enemy_collide(spike[i],px,py)==1){return 1;}
		}
	}
	
	return 0;
}

void spike_update(int px,int py)
{

	int i,j,c;
	int a,b,t;
	int g;
	int mg;
	
	const int dir[8]={0,-1, 1,0, 0,1, -1,0};

	int order[]={0,2,4,6};

	for(i=0;i<10;i++)
	{
		if (spike[i].a==1)
		{	
			if (spike[i].xdir==0 && spike[i].ydir==0)
			{
				// Jumble directions
				for(c=0;c<10;c++)
				{
					a=random(4);
					b=random(4);
					
					t=order[a];
					order[a]=order[b];
					order[b]=t;
				}
			
				// new direction
				for(c=0;c<4;c++)
				{
					j=order[c];
				
					spike[i].xdir=dir[j];
					spike[i].ydir=dir[j+1];
			
					// Check for a clear!
					mg=mine_get(spike[i].x+spike[i].xdir,spike[i].y+spike[i].ydir);
					if (mg==0 || mg==-1)
					{	
					break;
					}
				}
			}
			else
			{
				
				spike[i].ox+=(spike[i].xdir*2);
				spike[i].oy+=(spike[i].ydir*2);
				
				if (abs(spike[i].ox)==16 || abs(spike[i].oy)==16)
				{
					spike[i].ox=0;
					spike[i].oy=0;
					
					spike[i].x+=spike[i].xdir;
					spike[i].y+=spike[i].ydir;
						
					// Check for wall
					mg=mine_get(spike[i].x+spike[i].xdir,spike[i].y+spike[i].ydir);
					if (mg!=0 && mg!=-1)
					{
						// Direction not clear
						spike[i].xdir=0;
						spike[i].ydir=0;
					}
				
				}
			}
			
		}
	}
}


void spike_draw(struct module_t *ptr_main_module,int mx,int my)
{
	int i;
	int ax,ay;
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	for(i=0;i<10;i++)
	{
		if (spike[i].a==1)
		{
			ax=(spike[i].x-(mx*10))<<4;	// <<4 = *16
			ay=(spike[i].y-(my*6))<<4;
			Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_spike, ax+spike[i].ox,ay+spike[i].oy, BM_NORMAL );
		}
	}
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
}



