//
// Adventure Game for Cybiko by ssjx (2015)
//
// ** Chatting to people **
//
#include <cybiko.h>

// shop.c
void center(struct module_t *ptr_main_module,char *,int );


void shadow(struct module_t *ptr_main_module,char *,int );


struct Bitmap bmp_talkplayer,bmp_talkoldman,bmp_talkprof,bmp_talkguard,bmp_tblock;
struct Bitmap bmp_tpillar,bmp_stone[4],bmp_tbug,bmp_tgrass;


int waitinput(struct module_t *);
int talk_spr;

const char *chat[]={
"#oldman1",
"Good morning!",
"%Morning Mr Oldman!",
"Are you busy?",
"%Well, I do have...",
"Great! I need someone to/collect some things for/my breakfast!",
"%Fine.../What do you need then?",
"Milk, oats, fish, fruit.../If you press [T] later, you/can see the complete list.",
"%That sounds easy enough,/though I don't understand/the press tea part..",
"If you make it back safely,/I will give you an excellent/item as a reward!",
"%'Make it back safely'?/Oh dear...",
"@",
"#oldman2",
"If you need a reminder,/press [T] to see/what items I need!",
"%Okay, thanks!",
"@",
"#oldman3",
"Great! You got all/my stuff!",
"%The fruit was a/pain to get..",
"Yeah, those ghosts/sure like their fruit..",
"Anyway, here's a/reward for your troubles!",
"%What is it??",
"Some ancient thing, I think/it's called an 'Air Stone'",
"%Okaay...",
"Have you been to the/mountains? I've heard/some interesting stuff/is happening up there!",
"%The guard is not/letting anyone pass...",
"The guard can be stubborn,/but if you speak to him, he/may give you an idea of/how to get passed...",
"@",
"#oldman4",
"Have you been/to the mountains yet?",
"%Not yet..",
"@",
"#guard1",
"Sorry, I can't/let you pass!",
"%Er.. Why not?",
"Recent tremors have/uncovered ancient/ruins in the mountains!",
"%That's interesting!",
"It could be very/dangerous up there!",
"%Oh..",
"@",
"#guard2",
"Guarding is so boring.../Wish I had some sweets to/suck on...",
"%Hmm.../Sweets, eh..",
"@",
"#guard3",
"Sorry, I can't/let you pass!",
"%<You give the/guard the sweets>",
"For me? Thanks!/I guess I can let you/pass, just be careful!",
"%Thanks!",
"@",
"#guard4",
"Slurp.../Slurp.../Slurp...",
"@",
"#prof1",
"Hello stranger!/I am Professor White!",
"%Hi, Mr Oldman said I/should take a look up here!",
"Oh, yes. Last weeks quake/unearthed the entrance to/this cave!",
"The pillars here look like/they are for some kind/of ancient stone to sit on...",
"%Something like this/Air Stone perhaps?",
"I wonder what would/happen if we put this stone/on one of the pillars?",
"@",
"#prof2",
"Yikes! That tremor/must mean the/stone belongs here!",	
"There should be 3 more/stones hidden in town! If/you can find them for me..",
"..I bet we would see/something more/interesting then!",
"%Okay, but if the planet/suddenly splits in half,/it's your fault...",
"That earlier tremor may/have opened up new areas/for you to explore.",
"%One more thing, what's/with those monsters?",
"Those green things below?/No idea, I guess they must/have been dormant before?",
"%They don't look like they/come from around here..",
"Best avoid them If you can!/Now get going/and be careful!",
"@",
"#prof3",
"Not found all the stones yet?",
"%Still looking!",
"That earlier tremor may/have opened up new areas/for you to explore.",
"%Got it! Thanks!",
"@",
"#prof4",
"Excellent! You have all/of the stones! Let's see/what happens now!",
"%Should we be wearing/goggles for this?",
"@",
"#prof5",
"%What the heck was that?!",
"It appears we've/been transported/to another world!",
"%How do we get home!?",
"These pillars look like/the ones in the cave, looking/at the natives. They must",
"have used similar stones/to transport to our world.",
"%So we need another/4 stones then?",
"I think so...",
"@"

};


void talk_gfx()
{
	//
	struct Input * ptr_input;
	int i;



	Bitmap_ctor(&bmp_talkplayer);
	ptr_input = open_resource_Ex( "talk_player.pic" );
	if (!Bitmap_load( &bmp_talkplayer, ptr_input ))
	{
		TRACE("Error talking player");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
	Bitmap_ctor(&bmp_talkoldman);
	ptr_input = open_resource_Ex( "talk_oldman.pic" );
	if (!Bitmap_load( &bmp_talkoldman, ptr_input ))
	{
		TRACE("Error talking oldman");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
		Bitmap_ctor(&bmp_talkguard);
	ptr_input = open_resource_Ex( "talk_guard.pic" );
	if (!Bitmap_load( &bmp_talkguard, ptr_input ))
	{
		TRACE("Error talking guard");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
	Bitmap_ctor(&bmp_talkprof);
	ptr_input = open_resource_Ex( "talk_prof.pic" );
	if (!Bitmap_load( &bmp_talkprof, ptr_input ))
	{
		TRACE("Error talking prof");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//
	
		//	
	Bitmap_ctor(&bmp_tblock);	
	ptr_input = open_resource_Ex( "wall.pic" );
	if (!Bitmap_load( &bmp_tblock, ptr_input ))
	{
		TRACE("Error loading block(mountain)");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//

	Bitmap_ctor(&bmp_tpillar);	
	ptr_input = open_resource_Ex( "talk_pillar.pic" );
	if (!Bitmap_load( &bmp_tpillar, ptr_input ))
	{
		TRACE("Error loading pillar(mountain)");
	}
	Input_dtor( ptr_input, FREE_MEMORY );
	//

	Bitmap_ctor(&bmp_tbug);	
	ptr_input = open_resource_Ex( "talk_bug.pic" );
	if (!Bitmap_load( &bmp_tbug, ptr_input ))
	{
		TRACE("Error loading bug(mountain)");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	Bitmap_ctor(&bmp_tgrass);	
	ptr_input = open_resource_Ex( "talk_grass.pic" );
	if (!Bitmap_load( &bmp_tgrass, ptr_input ))
	{
		TRACE("Error loading grass(mountain)");
	}
	Input_dtor( ptr_input, FREE_MEMORY );

	//
	// Stones
	//
	
	for(i=0;i<4;i++)
	{
	Bitmap_ctor(&bmp_stone[i]);
	}

	ptr_input = open_resource_Ex( "stone_air.pic" );
	if (!Bitmap_load( &bmp_stone[0], ptr_input )){TRACE("Error loading talk stone");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "stone_earth.pic" );
	if (!Bitmap_load( &bmp_stone[1], ptr_input )){TRACE("Error loading talk stone");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "stone_fire.pic" );
	if (!Bitmap_load( &bmp_stone[2], ptr_input )){TRACE("Error loading talk stone");}
	Input_dtor( ptr_input, FREE_MEMORY );
	
	ptr_input = open_resource_Ex( "stone_water.pic" );
	if (!Bitmap_load( &bmp_stone[3], ptr_input )){TRACE("Error loading talk stone");}
	Input_dtor( ptr_input, FREE_MEMORY );


}


void talk_draw(struct module_t *ptr_main_module, int line)
{

	int tpos=0,width,first;
	int pos=0;
	char txt[100],*tmp;
	int ext=0,i,j,c,start=0;
	int ypos=0;
		
	tmp=(char *)malloc(100); 
	
	first=line;
	
	if (tmp==0)
	{
		TRACE("Not Enough Memory (TMP Buffer)..");
		return;
	}
	

	do{
		TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
		TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
		//
		// draw 2 talkers
		//
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
		TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
		
		// player
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkplayer, 32,90-32, BM_NORMAL );
		
		switch(talk_spr)
		{
		case 0:
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkoldman, 160-64,90-32, BM_NORMAL );
		break;
		
		case 1:
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkguard, 160-64,90-32, BM_NORMAL );
		break;
		
		case 2:
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkprof, 160-64,90-32, BM_NORMAL );
		break;
		}	

	
		// Put drawing back to normal!
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
		///
		TGraph_set_color( ptr_main_module->m_gfx, CLR_LTGRAY );
		TGraph_fill_rect(ptr_main_module->m_gfx, 0, 90, 160, 10 );
		
		TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
		DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Press Enter..", 1,90 );
		
		//TRACE("Line %d",line);
		
		start=0;
		
		//printf("%s\n--\n",txt);
	
		ypos=0;
		tpos=line;
		
		for(j=0;j<2;j++)
		{
			tpos=(line+j-1);
			
			if (tpos<first)
			{
				ypos=30;
			}
			else
			{
				strncpy(txt,chat[tpos],sizeof(txt)-1);
				//TRACE("Line: [%s]",tmp);
			
				if (txt[0]=='@')
				{
					ext=1;
					break;
				}
				else
				{
					c=0;
					start=0;
					for(i=0;i<strlen(txt);i++)
					{
					
						if (txt[i]=='/' || i==strlen(txt)-1)
						{
							// needed to stop single/last lines being trimmed
							if (i==strlen(txt)-1){c++;}
							
							memset(tmp,0,100);
							strncpy(tmp,chat[tpos]+start,c);
							
							//TRACE("%d: [%s]",c,tmp);
							
							if (txt[0]!='%')
							{
								TGraph_set_color( ptr_main_module->m_gfx, CLR_LTGRAY );
								TGraph_fill_rect(ptr_main_module->m_gfx, 10, ypos, 150, 10 );
				
								width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),tmp );
								pos=160-width; 	
								
								TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
							}
							else
							{
								// remove % from start
								if (start==0)
								{
								strncpy(tmp,chat[tpos]+start+1,c-1);
								}
								
								TGraph_set_color( ptr_main_module->m_gfx, CLR_DKGRAY );
								TGraph_fill_rect(ptr_main_module->m_gfx, 0, ypos, 150, 10 );
								pos=1;
								
								TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
							}
							
							//TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
							DisplayGraphics_draw_text( ptr_main_module->m_gfx, tmp, pos,ypos );
							
							start=i+1;
							c=0;
							
							ypos+=10;
						}
						else
						{
							c++;
						}
					} 
				}
			}	
		
			// If we are showing the line we want (not previous)
			if (tpos==line){break;}
			//probably hit end of talking
			if (ext==1){break;}		
		}
		
		//
		//
		//
	
		if (ext==0)
		{
			DisplayGraphics_show(ptr_main_module->m_gfx );
				
			switch(waitinput(ptr_main_module))
			{
				case KEY_ENTER:
					//if (line==27){ext=1;}else{line+=3;}
					line++;	
				break;
					
				case KEY_ESC:
					ext=1;
				break;
			}
		}
		
	}while(ext==0);	
		
	//TRACE("End of talking!");	
		
	free(tmp);
}

void talk_quake(struct module_t *ptr_main_module,int stones)
{
	int y=0,ydir=-2,cnt=0,ext=0,i;

	do
	{
		TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
		TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
		//
		// draw 2 talkers
		//
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
		TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
		
		// player
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkplayer, 0,(90-32)-y, BM_NORMAL );
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkprof, 160-32,(90-32)-y, BM_NORMAL );
	
		for(i=0;i<10;i++)
		{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tblock, i*16,90-y, BM_NORMAL );
		}
	
		for(i=0;i<4;i++)
		{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tpillar, 16+(i*32) ,(90-32)-y, BM_NORMAL );
		}
		
		TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
		for(i=0;i<stones;i++)
		{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_stone[i], 16+(i*32)+8 ,(90-48)-y, BM_NORMAL );
		}
		
	
		// Put drawing back to normal!
		TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
	
		y+=ydir;
		
		if (y==-4 || y==4)
		{
			ydir*=-1;
			cnt++;
			
			if (cnt==10)
			{
				ext=1;
			}
		}
			
		DisplayGraphics_show(ptr_main_module->m_gfx );
		
	}while(ext==0);
}

void talk_teleport(struct module_t *ptr_main_module)
{
	int y=0,ydir=-2,cnt=0,ext=0,i,j;
	int offset;

	char *tmp,*scr;
	
	tmp=(char *)malloc(4000); 
	
	if (tmp==0)
	{
		TRACE("Not Enough Memory (Talk T Buffer)..");
		return;
	}

	scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

	//
	// Alieny World
	//
	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
	
	// 11 10 01 00 
	offset=0;
	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x99,40);
		memset(scr+offset+40,0x66,40);
		offset+=80;
	}

	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x44,40);
		memset(scr+offset+40,0x11,40);
		offset+=80;
	}
	
	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x01,40);
		memset(scr+offset+40,0x10,40);
		offset+=80;
	}
	//
	// draw 2 talkers
	//
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	// player
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkplayer, 0,(90-32)-y, BM_NORMAL );
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkprof, 160-32,(90-32)-y, BM_NORMAL );

	for(i=0;i<10;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tgrass, i*16,90-y, BM_NORMAL );
	}

	
	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tpillar, 16+(i*32) ,(90-32)-y, BM_NORMAL );
	}
	
	
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tbug, 16+(i*32) ,(90-64)-y, BM_NORMAL );
	}
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
	
	memcpy(tmp,scr,4000);


	//
	//
	//


	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
	//
	// draw 2 talkers
	//
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	// player
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkplayer, 0,(90-32)-y, BM_NORMAL );
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkprof, 160-32,(90-32)-y, BM_NORMAL );

	for(i=0;i<10;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tblock, i*16,90-y, BM_NORMAL );
	}

	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tpillar, 16+(i*32) ,(90-32)-y, BM_NORMAL );
	}
	
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_stone[i], 16+(i*32)+8 ,(90-48)-y, BM_NORMAL );
	}
	

	// Put drawing back to normal!
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
	//
	TGraph_set_color( ptr_main_module->m_gfx, CLR_DKGRAY );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Press Enter..", 1,1 );
	
	DisplayGraphics_show(ptr_main_module->m_gfx );
		
	// Transition
	waitinput(ptr_main_module);
	
	offset=0;
	
	for(i=0;i<20;i++)
	{
		offset=19-i;
		for(j=0;j<100;j++)
		{
			scr[offset]=tmp[offset];
			offset+=40;
		}
		
		offset=20+i;
		for(j=0;j<100;j++)
		{
			scr[offset]=tmp[offset];
			offset+=40;
		}
		DisplayGraphics_show(ptr_main_module->m_gfx );
	}
	
	//
	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Press Enter..", 1,1 );
	DisplayGraphics_show(ptr_main_module->m_gfx );

	
	waitinput(ptr_main_module);

}

void talk_end(struct module_t *ptr_main_module)
{
	int y=0,cnt=0,ext=0,i,j;
	int offset;

	char *scr;

	scr=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

	//
	// Alieny World
	//
	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );
	
	// 11 10 01 00 
	offset=0;
	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x99,40);
		memset(scr+offset+40,0x66,40);
		offset+=80;
	}

	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x44,40);
		memset(scr+offset+40,0x11,40);
		offset+=80;
	}
	
	for(i=0;i<5;i++)
	{
		memset(scr+offset,0x01,40);
		memset(scr+offset+40,0x10,40);
		offset+=80;
	}
	//
	// draw 2 talkers
	//
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_OR );
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_WHITE );
	
	// player
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkplayer, 0,(90-32)-y, BM_NORMAL );
	Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_talkprof, 160-32,(90-32)-y, BM_NORMAL );

	for(i=0;i<10;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tgrass, i*16,90-y, BM_NORMAL );
	}

	
	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tpillar, 16+(i*32) ,(90-32)-y, BM_NORMAL );
	}
	
	
	TGraph_set_bkcolor( ptr_main_module->m_gfx, CLR_LTGRAY );
	for(i=0;i<4;i++)
	{
		Graphics_draw_bitmap( ptr_main_module->m_gfx, &bmp_tbug, 16+(i*32) ,(90-64)-y, BM_NORMAL );
	}
	
	TGraph_set_draw_mode( ptr_main_module->m_gfx, DM_PUT );
	
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
	
	shadow(ptr_main_module,"WELL DONE!",0);
	shadow(ptr_main_module,"You have completed",10);
	shadow(ptr_main_module,"your adventure...",20);

	shadow(ptr_main_module,"...and maybe started another!",40);
	
	shadow(ptr_main_module,"Thanks for playing!",60);
	
	
	
	
	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Press Escape..", 1,91 );
	DisplayGraphics_show(ptr_main_module->m_gfx );
	
	
	do{}while(waitinput(ptr_main_module)!=KEY_ESC);
	
}

int talk_start(char *txt)
{
	int i=0,ext=0;
	
	if (txt[0]=='#')
	{
		if (txt[1]=='o'){talk_spr=0;}//oldman
		if (txt[1]=='g'){talk_spr=1;}//guard
		if (txt[1]=='p'){talk_spr=2;}//prof
	}
	
		do
		{
			if (strcmp(chat[i],txt)==0)
			{
				return (i+1);
			}
			else
			{
				if (strcmp(chat[i],"@end")==0)
				{
				ext=1;
				}
			}
			i++;
		}while(ext==0);
	
	return -1;
}

