//
// Adventure Game for Cybiko by ssjx (2015)
//
// ** Tasks **
//
#include <cybiko.h>

// in inventory.c
int inv_count(char *);

// utils.c
int waitinput(struct module_t *);

int current_task=0;

int complete[4];


char task_title[40];
char task_desc[40];

struct mytask
{
char required[30];
int qty;
};

struct mytask task[6];

void task_reset()
{
	int i;
	
	for(i=0;i<4;i++)
	{
		complete[i]=0;
	}
	
	for(i=0;i<6;i++)
	{
		memset(task[i].required,0,sizeof(task[i].required));
		task[i].qty=0;
	}

}

void task_clear()
{
	int i;

	for(i=0;i<6;i++)
	{
		memset(task[i].required,0,sizeof(task[i].required));
		task[i].qty=0;
	}
}

void task_set(int tno)
{
	current_task=tno;

	task_clear();

	switch(tno)
	{
	case 0:
		// No Task
		strncpy(task_title,"No tasks yet...",sizeof(task_title)-1);
		
		if (complete[1]==0)
		{
			strncpy(task_desc,"Chat to Mr Oldman?",sizeof(task_desc)-1);
		}
		else
		{
			if (complete[2]==0)
			{
				strncpy(task_desc,"Chat to the Guard?",sizeof(task_desc)-1);
			}
			else
			{
				if (complete[3]==0)
				{
					strncpy(task_desc,"Go to the mountains?",sizeof(task_desc)-1);
				}
			}
		}
		
		
		
		
	break;
	
	case 1:
		// Milk Oats Fish Apple Cherry
		strncpy(task_title,"Food for Mr Oldman",sizeof(task_title)-1);
		strncpy(task_desc,"Collect the following:",sizeof(task_desc)-1);
		
		strncpy(task[0].required,"Apple",sizeof(task[0].required)-1);
		task[0].qty=2;
		
		strncpy(task[1].required,"Cherry",sizeof(task[1].required)-1);
		task[1].qty=2;
		
		strncpy(task[2].required,"Fish",sizeof(task[2].required)-1);
		task[2].qty=2;
		
		strncpy(task[3].required,"Oats",sizeof(task[3].required)-1);
		task[3].qty=1;
		
		strncpy(task[4].required,"Milk",sizeof(task[4].required)-1);
		task[4].qty=1;
	break;
	
	case 2:
		strncpy(task_title,"The guard's sweet tooth",sizeof(task_title)-1);
		strncpy(task_desc,"Get some sweets for the guard!",sizeof(task_desc)-1);
		
		strncpy(task[0].required,"Sweets",sizeof(task[0].required)-1);
		task[0].qty=1;
	break;
	
	case 3:
		strncpy(task_title,"Ancient Artifacts",sizeof(task_title)-1);
		strncpy(task_desc,"Find the 4 Elemental Stones",sizeof(task_desc)-1);
		
		strncpy(task[0].required,"Air Stone",sizeof(task[0].required)-1);
		task[0].qty=1;
		
		strncpy(task[1].required,"Earth Stone",sizeof(task[1].required)-1);
		task[1].qty=1;
		
		strncpy(task[2].required,"Fire Stone",sizeof(task[2].required)-1);
		task[2].qty=1;
		
		strncpy(task[3].required,"Water Stone",sizeof(task[3].required)-1);
		task[3].qty=1;
	break;
	
	}


}

void task_draw(struct module_t *ptr_main_module)
{
	int ext=0,i,j;
	char tmp[40];
	int qty,wait;

	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
     	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );

	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );	
	TGraph_draw_line( ptr_main_module->m_gfx, 0, 11, 160, 11 );

	DisplayGraphics_draw_text( ptr_main_module->m_gfx, task_title, 1, 1 );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, task_desc, 1, 12 );
	
	j=0;
	for(i=0;i<6;i++)	
	{
		if (task[i].qty>1)
		{
			sprintf(tmp,"%s x%d",task[i].required,task[i].qty);
		}
		else
		{
			if (task[i].qty==1)
			{
				strncpy(tmp,task[i].required,sizeof(tmp)-1);
			}
		}
		
		if (task[i].qty>0)
		{
			qty=inv_count(task[i].required);
			//TRACE("Task: %s %d / %d",task[i].required,task[i].qty,qty);
				
			if (qty>=task[i].qty)
			{
				sprintf(tmp,"%s - Done",tmp);
			}
	
			DisplayGraphics_draw_text( ptr_main_module->m_gfx,tmp, 1, 25+(j*10) );
			
			j++;
		}	
	}
	
	///
	TGraph_set_color( ptr_main_module->m_gfx, CLR_LTGRAY );
	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 90, 160, 10 );
	
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "Escape to Exit..", 1,90 );
	
	DisplayGraphics_show(ptr_main_module->m_gfx );
		
	do{
		wait=waitinput(ptr_main_module);
		if (wait==KEY_ESC || wait==KEY_ESC){ext=1;}
	
	}while(ext==0);

}


int task_complete()
{
	int i,cnt=0;

	for(i=0;i<6;i++)
	{
		if (strlen(task[i].required)>0)
		{
			cnt=inv_count(task[i].required);	
			if (cnt<task[i].qty)
			{
			TRACE("Needed: [%s] %d",task[i].required,task[i].qty);
			
			return -1;
			}
		}
		
	}

complete[current_task]=1;

return 1;
}

int task_status(int t)
{
return complete[t];
}

int task_current()
{
return current_task;
}




