//
// Adventure Game for Cybiko by ssjx (2015)
//

#include <cybiko.h>

// shop.c
void center(struct module_t *ptr_main_module,char *,int );
void shadow(struct module_t *ptr_main_module,char *,int );


int waitinput(struct module_t *);

int title_draw(struct module_t *ptr_main_module)
{
	int ext=0;
	
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );	

	shadow(ptr_main_module,"Adventure for Breakfast!",20);
	shadow(ptr_main_module,"by ssjx",30);
	
	shadow(ptr_main_module,"Space to start",60);
	shadow(ptr_main_module,"Escape to exit",70);
	
	DisplayGraphics_show(ptr_main_module->m_gfx );

	if (waitinput(ptr_main_module)==KEY_ESC)
	{
		TRACE("Escape from the title screen...");
		ext=1;
	}

return ext;
}

void title_welcome(struct module_t *ptr_main_module)
{
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );	
	
	shadow(ptr_main_module,"Welcome to a small",20);
	shadow(ptr_main_module,"town in Gardenia!",30);
	
	shadow(ptr_main_module,"Mr Oldman looks like he ",50);
	shadow(ptr_main_module,"wants to speak to you...",60);
		
	shadow(ptr_main_module,"Space to continue",80);
	
	DisplayGraphics_show(ptr_main_module->m_gfx );
	
	waitinput(ptr_main_module);
}


int loading_screen(struct module_t *ptr_main_module, int p)
{
	int i=0,x;
	const int gap=(160-(11*10))/12;
		
	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
     	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );

	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
	center(ptr_main_module,"Adventure for Breakfast!",20);
	
	if (p<8)
	{
		center(ptr_main_module,"Loading graphics!",40);
	}
	else
	{
		center(ptr_main_module,"Almost done...",40);
	}
	
	for(i=0;i<11;i++)
	{
		x=(i*10)+((i+1)*gap);
		
		DisplayGraphics_draw_rect( ptr_main_module->m_gfx, x, 64, 10, 10);
		
		if (i<=p)
		{
		DisplayGraphics_fill_rect( ptr_main_module->m_gfx,  x, 64, 10, 10);
		}
	
	}

	//footer
	TGraph_draw_line( ptr_main_module->m_gfx, 0, 89, 160, 89 );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "http://ssjx.co.uk", 1, 90 );
	DisplayGraphics_draw_text( ptr_main_module->m_gfx, "v0.1", 140, 90 );
	
	DisplayGraphics_show(ptr_main_module->m_gfx );
}




void sign_draw(struct module_t *ptr_main_module,int mx, int my)
{
	int i,offset;

	const char *txt[]={
	"","Welcome to Gardenia!","","Enjoy your visit!","",
	"This way to the","","HAUNTED FOREST!","","Beware of ghosts!",
	"This way to the","","FISHING LAKE!","","Catch some fish!",
	"Visit the local shop!","","Come in and buy things!","","Diamonds accepted!",
	"Danger!","","HOLES!","","Press Enter to Enter!",
	"Information!","","Press 'x' to Quit","","If you really want too.."
	};

	TGraph_set_color( ptr_main_module->m_gfx, CLR_LTGRAY );
     	TGraph_fill_rect(ptr_main_module->m_gfx, 0, 0, 160, 100 );

	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );
     	TGraph_fill_rect(ptr_main_module->m_gfx, 10, 10, 140, 80 );

	TGraph_set_color( ptr_main_module->m_gfx, CLR_WHITE );	
	center(ptr_main_module,"Sign reads:",0);

	// Sort out which text to show
	offset=0;
	if (mx==11 && my==14){offset=5;}	// Forest
	if (mx==28 && my==8){offset=(2*5);}	// Fishing Lake
	if (mx==22 && my==15){offset=(3*5);}	// Welcome
	if (mx==4 && my==8){offset=(4*5);}	// Holes
	if (mx==6 && my==8){offset=(5*5);}	// x to quit
	
	TGraph_set_color( ptr_main_module->m_gfx, CLR_BLACK );
	
	for(i=0;i<5;i++)
	{	
		center(ptr_main_module,txt[offset+i],20+(i*10));
	}
		
	DisplayGraphics_show(ptr_main_module->m_gfx );

	waitinput(ptr_main_module);
	
}
