//
// Standard useful functions
//

#include <cybiko.h>
#include "header.h"

void snapshot(char *);

//
//
//
long swp(long num)
{
	long out;
	char *ptr_in,*ptr_out;
	
	ptr_in=&num;
	ptr_out=&out;
	
	ptr_out[0]=ptr_in[3];
	ptr_out[1]=ptr_in[2];
	ptr_out[2]=ptr_in[1];
	ptr_out[3]=ptr_in[0];
	
	return out;
}

//
//
//

int waitinput(struct module_t *ptr_main_module)
{
	struct Message* ptr_message;
	struct KeyParam* ptr_key_param;
	int num=0,exit=0;
	
	// Clear the message buffer of key up presses
	while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYUP, MSG_KEYUP ))
	{
	   	Message_delete( ptr_message );
	//	TRACE("Deleting message1");
	}
	     
	// Wait for a keypress
	do
	{
		ptr_message = cWinApp_get_message( ptr_main_module->m_process, 1, 1,MSG_USER );
			
		if(ptr_message->msgid==MSG_KEYUP)
		{
			ptr_key_param = Message_get_key_param( ptr_message );  
			num=ptr_key_param->scancode;
			exit=1;
		}    
		
		//cWinApp_defproc( ptr_main_module->m_process, ptr_message );
		Message_delete(ptr_message);
		ptr_message = NULL;
	
	}while(exit==0);
	
	//while(ptr_message = cWinApp_peek_message( ptr_main_module->m_process, TRUE, MSG_KEYDOWN, MSG_KEYDOWN ))
	//{
	   	Message_delete( ptr_message );
	//	TRACE("Deleting message1");
	//}
	
	
	return num;
}

//
//
//

int abs(int num)
{
	if (num<0){return -num;}
	return num;
}

//
//
//


void shadow(struct module_t *ptr_main_module,char *text,int y)
{
	int width,pos;
	
	width=Font_string_width( DisplayGraphics_get_font( ptr_main_module->m_gfx),text );
	
	pos=(160-width)>>1;	    
	if (pos<0){pos=0;}
	
	TGraph_set_color(ptr_main_module->m_gfx, CLR_WHITE );
	
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos+1, y );
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos-1, y );
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y+1 );
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y-1 );

	TGraph_set_color(ptr_main_module->m_gfx, CLR_BLACK );
	DisplayGraphics_draw_text(ptr_main_module->m_gfx,text, pos, y );
}


//
// Snapshot - Takes a screen grab and saves it as snapshot.pic
//

void snapshot(char *in)
{
	struct FileOutput file_output;
	long hd1,hd2;
	char fn[30],i=0,exists=0;
	FileOutput_ctor( &file_output );
	
	hd1=0x0201a064;
	hd2=0x0000a064;
	
	do
	{
		exists=0;
		memset(fn,0,sizeof(fn));
		sprintf(fn,"breakfast%d.pic",i);
		if( File_exists( fn )) {exists=1;i++;}
	}while(exists==1);
	
	if( FileOutput_open( &file_output, fn, TRUE ) )
	{
		FileOutput_write( &file_output,&hd1,4);
		FileOutput_write( &file_output,&hd2,4);
		FileOutput_write( &file_output,in,4000);
		
		TRACE("Snapshot Taken, saved as %s",fn);
	}
	
	FileOutput_dtor( &file_output, LEAVE_MEMORY );
}
